import json_log_formatter
import logging
import sys

from duration_formatter import DurationFormatter
from deprov_config import DeprovConfig


def setup_logging(config: DeprovConfig):
    formatter = json_log_formatter.JSONFormatter() if config.aws_logging else DurationFormatter()
    handler = logging.StreamHandler(sys.stdout)
    handler.setFormatter(formatter)
    handler.setLevel(config.log_level)
    logging.basicConfig(level=config.log_level, handlers=[handler])
