from typing import Type

from batched_sql_context import BatchedSqlContext
from deprov_config import DeprovConfig


class Deprovision(BatchedSqlContext):
    def __init__(self, db_connection, config: DeprovConfig, runner_type: Type):
        self._db_connection = db_connection
        self._runner_type = runner_type
        self._config = config
        self._cursor = None

    def run(self):
        with self._db_connection.cursor() as cursor:
            self._cursor = cursor
            self._runner_type(self).run()

    @property
    def cursor(self):
        return self._cursor

    @property
    def batch_size(self) -> int:
        return self._config.batch_size

    @property
    def dry_run(self) -> bool:
        return self._config.dry_run

    @property
    def link_batch_size(self) -> int:
        return self._config.link_batch_size
