import logging


class DurationFormatter(logging.Formatter):
    def __init__(self):
        super().__init__()
        self._default = logging.Formatter('%(asctime)s - %(levelname)s: %(message)s', datefmt='%m/%d/%Y %I:%M:%S %p')
        self._extra = logging.Formatter('%(asctime)s - %(levelname)s [%(duration)s]: %(message)s', datefmt='%m/%d/%Y %I:%M:%S %p')

    def format(self, record: logging.LogRecord) -> str:
        if getattr(record, 'duration', None):
            return self._extra.format(record)
        return self._default.format(record)
