class Singleton(type):
    """For speed, this singleton metaclass does not support inheritance."""
    _instance = None

    def __call__(cls, *args, **kwargs):
        if not cls._instance:
            cls._instance = super(Singleton, cls).__call__(*args, **kwargs)
        return cls._instance

